//
//  Action.swift
//  Quack
//
//  Created by Marco Fattorel on 21/01/2017.
//  Copyright © 2017 Marco Fattorel. All rights reserved.
//

import Foundation

class Action {
	let startTime: TimeInterval
	let duration: TimeInterval
	
	enum Button: String {
		case a = "A"
		case lt = "LT"
		case rt = "RT"
		case wrong
	}
	let press: Button
	
	var pad = false
	
	var move0 = false
	var move1 = false
	var move2 = false
	
	init(_ button: Button, _ start: TimeInterval, _ duration: TimeInterval) {
		press = button
		startTime = start
		self.duration = duration
	}
	
	func check(currentTime: TimeInterval) -> Bool {
		if currentTime < startTime || currentTime > startTime + duration {
			return false
		}
		return true
	}
	
	func check(valueA: Double) -> Int {
//		if currentTime < startTime || currentTime > startTime + duration {
//			return false
//		}
		if pad { return 0 }
		if valueA > 0.5 {
			pad = true
			if press != .a {
				return -10
			}
			else {
				return 20
			}
		}
		return 0
	}
	func check(valueRt: Double) -> Int {
//		if currentTime < startTime || currentTime > startTime + duration {
//			return false
//		}
		if pad { return 0 }
		if valueRt > 0.5 {
			pad = true
			if press != .rt {
				return -10
			}
			else {
				return 20
			}
		}
		return 0
	}
	func check(valueLt: Double) -> Int {
//		if currentTime < startTime || currentTime > startTime + duration {
//			return false
//		}
		if pad { return 0 }
		if valueLt > 0.5 {
			pad = true
			if press != .lt {
				return -10
			}
			else {
				return 20
			}
		}
		return 0
	}
	
	// move check
	func check(value0: Float) -> Int {
//		if currentTime < startTime || currentTime > startTime + duration {
//			return false
//		}
		if move0 { return 0 }
		if value0 > 2.0 {
			move0 = true
			if press != .a {
				return -10
			}
			else {
				return 20
			}
		}
		return 0
//		if press != .a || move0 { return false }
//		if value0 > 2.0 {
//			move0 = true
//			return true
//		}
//		return false
	}
	func check(value1: Float) -> Int {
		if move1 { return 0 }
		if value1 > 2.0 {
			move1 = true
			if press != .rt {
				return -10
			}
			else {
				return 20
			}
		}
		return 0
	}
	func check(value2: Float) -> Int {
		if move2 { return 0 }
		if value2 > 2.0 {
			move2 = true
			if press != .lt {
				return -10
			}
			else {
				return 20
			}
		}
		return 0
	}
}
