//
//  SceneKitExtension.swift
//  Quack
//
//  Created by Marco Fattorel on 21/01/2017.
//  Copyright © 2017 Marco Fattorel. All rights reserved.
//

import SceneKit
import SpriteKit

extension SCNAudioSource {
	convenience init(name: String, volume: Float = 1.0, positional: Bool = true, loops: Bool = false, shouldStream: Bool = false, shouldLoad: Bool = true) {
		self.init(named: "Asset.scnassets/sounds/\(name)")!
		self.volume = volume
		self.isPositional = positional
		self.loops = loops
		self.shouldStream = shouldStream
		if shouldLoad {
			load()
		}
	}
}

extension SKSpriteNode {
	convenience init(imageNamed name: String, position: CGPoint, scale: CGFloat = 1.0) {
		self.init(imageNamed: "Asset.scnassets/" + name)
		self.position = position
		xScale = scale
		yScale = scale
	}
}
